local leadWire = ...

--------------------------------------------------------------------------
local LEAD_WIRE_ALIGN_COMP = {
	TypeName = _PrefixAsset .. "LEAD_WIRE_ALIGN_COMP",
	ParentType = "COMPONENT",
	Properties = {}
}

--------------------------------------------------------------------------
function LEAD_WIRE_ALIGN_COMP:create()
end

--------------------------------------------------------------------------
function LEAD_WIRE_ALIGN_COMP:init()
        self.WindowPosition = self:getOwner():getGlobalPosition()
        leadWire:log("Start GlobalPosition = " .. tostring(self:getOwner():getGlobalPosition()))
        if self:computeElevation() then
            self:getOwner():setGlobalPosition(self.WindowPosition)  
            leadWire:log("<<<<<<Elevation y = " .. self.WindowPosition[2])
        end
        self.LeadWire_PositionY = self.WindowPosition[2]
        leadWire:log("End GlobalPosition = " .. tostring(self:getOwner():getGlobalPosition()))
end

--------------------------------------------------------------------------
function LEAD_WIRE_ALIGN_COMP:computeElevation()
        leadWire:log("computeElevation")
        local LeadWireName = _PrefixAsset .. "LEAD_WIRE_COMP"
       
        local _currentObject = self:getOwner() 
        local _leadWire
        for i=0,20, 1 do
            local _parent = _currentObject:getParent()
            if _parent == nil then    
                leadWire:logWarning("No _parent defined")
                return false
            end
            if _parent.Name == _PrefixAsset .. "MONUMENT_NAME" then    
                leadWire:logWarning("All monument scheduled")
                _leadWire = _parent:findFirstObjectWithComponentDown(LeadWireName)        
                if _leadWire == nil then
                    leadWire:logWarning("No leadWire defined yet parent = " .. _parent.Name)
                    return false
                else
                    leadWire:logWarning("leadWire found with parent = " .. _parent.Name)
                    break
                end
            end
            _currentObject = _parent
        end
        leadWire:log("_leadWire = " .. tostring(_leadWire))
        if not _leadWire.LeadWire_IsSet then
            leadWire:logWarning("leadWire not set")
            return false
        end
        if _leadWire:getOwner() == nil then    
            leadWire:logWarning("No _leadWire owner defined")
            return false
        end
        leadWire:log("_leadWire:getOwner() = " .. tostring(_leadWire:getOwner()))
        local _leadWireObject = _leadWire:getOwner()
        leadWire:log("_positionFlag = " .. tostring(_leadWireObject:getGlobalPosition()))
        self.WindowPosition[2] = _leadWireObject:getGlobalPosition()[2]
        return true       
end

--------------------------------------------------------------------------
function LEAD_WIRE_ALIGN_COMP:update()
        if self.LeadWire_PositionY == self:getOwner():getGlobalPosition()[2] then
            return
        end
        if self:computeElevation() then
            self:getOwner():setGlobalPosition(self.WindowPosition)  
            leadWire:log("++++++Elevation y = " .. self.WindowPosition[2])
        end
end

--------------------------------------------------------------------------
leadWire:registerClass(LEAD_WIRE_ALIGN_COMP)
